/*******************************************************************************
 *  Copyright 2017-2018 Centre for Development of Advanced Computing(C-DAC), Pune
 *  
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *  
 *   http://www.apache.org/licenses/LICENSE-2.0
 *  
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *******************************************************************************/
package cdac.medinfo.sdk.dcm30_04.templates.cid;

import java.util.Locale;



import cdac.medinfo.sdk.dcm30_04.templates.dicomsnomedmap.EnumChestCardiacSNOMEDMap;
import cdac.medinfo.sdk.dcm30_04.templates.enums.EnumCodingSchemeDesignator;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cm.EnumCM_ValveAreas;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cm.EnumCM_ValveAreasNonMitral;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cv.EnumCV_ValveAreas;
import cdac.medinfo.sdk.dcm30_04.utils.DicomConfig;
import cdac.medinfo.sdk.dcm30_04.utils.DicomLogger;
import cdac.medinfo.sdk.dcm30_04.utils.ResourceBundleWrapper;

/**
 * This class represents ValveAreas - CID3615
 */
public class ValveAreas_CID3615 
{
	
	/**
	 * The Code Value for template.
	 */
	private String strCodeValue = null;
	/**
	 * The SNOMED CT ID for template.
	 */
	private String strSNOMEDCTID = null;
	/**
	 * The Code Meaning for template.
	 */
	private String strCodeMeaning = null;
	
	/**
	 * The Coding Scheme Designator for template.
	 */
	private String strCodingSchemeDesignator;
	
	/**
	 * Object of ValveAreasNonMitral_CID3614
	 */
	private ValveAreasNonMitral_CID3614 objValveAreasNonMitral_CID3614;
	
	/**
	 * Instantiates a new ValveAreas_CID3615 Template 
	 */
	public ValveAreas_CID3615()
	{
		
	}
	
	/**
	 * Retrieves the value for Code Meaning.
	 * @return String value for Code Meaning.
	 */
	public String getCodeMeaning()
	{
		return strCodeMeaning;
	}

	/**
	 * Retrieves the value for Code Value.
	 * @return String value for Code Value.
	 */
	public String getCodeValue() 
	{
		return strCodeValue;
	}

	/**
	 * Retrieves the value for Coding Scheme Designator.
	 * @return String value for Coding Scheme Designator.
	 */
	public String getCodingSchemeDesignator() 
	{
		return strCodingSchemeDesignator;
	}
	/**
	 * Retrieves the value for SNOMED-CT ID.
	 * @return String value for SNOMED-CT ID.
	 */
	public String getSNOMEDCTID() 
	{
		return strSNOMEDCTID;
	}
	/**
	 * Sets the Code Value according to Code Meaning.
	 * @param enumValveAreas Object of EnumCM_ValveAreas represents Code Meaning.
	 */
	private void setCodeValue(EnumCM_ValveAreas enumValveAreas)
	{
		switch(enumValveAreas)
		{
		case MITRAL_VALVE_AREA: this.strCodeValue =EnumCV_ValveAreas.MITRAL_VALVE_AREA_F_02320.getValue(); break;
		
		}
	}
	/**
	 * Sets the SNOMED-CT ID.
	 * @param enumValveAreas Object of EnumCM_ValveAreas represents Code Meaning.
	 */
	private void setSNOMEDCTID(EnumCM_ValveAreas enumValveAreas)
	{
		switch(enumValveAreas)
		{
		case MITRAL_VALVE_AREA : this.strSNOMEDCTID =EnumChestCardiacSNOMEDMap.MITRAL_VALVE_AREA.getSNOMEDCTID(); break;
		}
	}
	/**
	 * Sets the value for ValveAreas
	 * @param enumValue This Enum value can be one of the following enums - EnumCM_ValveAreasNonMitral, EnumCM_ValveAreas,
	 */
	public void setValveAreas(Enum enumValue)
	{
		if (enumValue instanceof EnumCM_ValveAreasNonMitral) 
		{
			/**
			 * Casting EnumValue to required Enum.
			 */
			EnumCM_ValveAreasNonMitral new_enumValveAreasNonMitral = (EnumCM_ValveAreasNonMitral) enumValue;
			
			/**
			 * Creating object of require CID with respect to enum and setting value accordingly.
			 */
			if(null== this.objValveAreasNonMitral_CID3614)
	this.objValveAreasNonMitral_CID3614 = new ValveAreasNonMitral_CID3614();
			this.objValveAreasNonMitral_CID3614.setValveAreasNonMitral(new_enumValveAreasNonMitral);
			
			/**
			 * Retrieving attributes and setting it to member variables. 
			 */
			this.strCodeMeaning = objValveAreasNonMitral_CID3614.getCodeMeaning();
			this.strCodeValue = objValveAreasNonMitral_CID3614.getCodeValue();
			this.strCodingSchemeDesignator = objValveAreasNonMitral_CID3614.getCodingSchemeDesignator();
			this.strSNOMEDCTID = objValveAreasNonMitral_CID3614.getSNOMEDCTID();
		}
		else if (enumValue instanceof EnumCM_ValveAreas) 
		{
			/**
			 * Casting EnumValue to required Enum.
			 */
			EnumCM_ValveAreas new_enumEnumValveAreas = (EnumCM_ValveAreas) enumValue;
			
			/**
			 * Retrieving attributes and setting it to member variables. 
			 */
			this.strCodeMeaning = new_enumEnumValveAreas.getValue();
			this.strCodingSchemeDesignator = EnumCodingSchemeDesignator.SRT.getValue();
			setCodeValue(new_enumEnumValveAreas);
			setSNOMEDCTID(new_enumEnumValveAreas);
		}
		else
		{
			if(DicomConfig.createInstance().isLoggingOn())
			{
				DicomLogger objDicomLogger = DicomLogger.getLogger();
				objDicomLogger.log(ResourceBundleWrapper.getValue("warning","InvalidEnumeratedValue",new Locale(DicomConfig.createInstance().getLocale())));
			}
		}
	}
}
